<TeXmacs|1.0.7.15>

<style|<tuple|article|templates>>

<\body>
  <doc-data|<doc-title|<TeXmacs> templates>>

  The <src-macro|save-chunk> macro is used to define a document block with
  optional parameters that can then be re-used with different values for
  those parameters.

  <section|Simple templates>

  For instance, to describe brushing ones teeth but permitting for variations
  we could define:

  <inactive*|<save-chunk|brush-teeth|Brush your teeth carefully for
  <placeholder|duration|2 minutes>, <placeholder|frequency|2> times a day>>

  When this <em|definition> appears the defining document, it would show as:

  <save-chunk|brush-teeth|Brush your teeth carefully for
  <placeholder|duration|2 minutes>, <placeholder|frequency|2> times a day>

  The place-holders are highlighted with flags and are editable by
  back-space.

  We could then emit these instructions with variation using:

  <inactive*|<brush-teeth>>

  Which renders as:

  <brush-teeth|1|3>

  However we can use a <src-macro|with> block to override the defaults:
  <inactive*|<with|duration|1 minute|frequency|5|<brush-teeth>>> which
  renders as: <with|duration|1 minute|frequency|5|<brush-teeth>>

  <section|Image overlays>

  Templates can be even more useful for overlaying images, particularly
  screenshots.

  This means that you can take a series of screen-shots which illustrate a
  general action, but then render the screen-shot with details that show the
  particular action.

  Here we will define a template that shows using the windows start button
  and a place-holder <em|command>.

  <save-chunk|run-command|<imagerys|<image|start-run.png|348px|187px||>|<with|gr-mode|<tuple|group-edit|move>|gr-frame|<tuple|scale|1cm|<tuple|0tmpt|0tmpt>>|gr-as-visual-grid|off|gr-edit-grid|<tuple|empty>|<graphics||<text-at|<underlay|<value|pic>>|<point|0|0>>|<text-at|<backgrounded|white|<placeholder|command|type-command-here>
  \ \ \ \ \ \ \ >|<point|1.31611970234159|1.77277804206906>>>>>>

  \;

  We can use this to show running specific commands, this time we will use
  <inactive*|<assign|command|cmd.exe>><assign|command|cmd.exe>

  <run-command>
</body>

<\initial>
  <\collection>
    <associate|language|british>
    <associate|preamble|false>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|auto-1|<tuple|1|1>>
    <associate|auto-2|<tuple|2|1>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|toc>
      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|1<space|2spc>Simple
      templates> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-1><vspace|0.5fn>

      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|2<space|2spc>Image
      overlays> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-2><vspace|0.5fn>
    </associate>
  </collection>
</auxiliary>